define(['BaseView', 'Model', 'Store', 'text!TemplatesActivitySignupend', 'util', 'UISlide'], function(BaseView, models, store, tplArticleview,  util, UISlide) {
    var isLogin = util.isLogin();
    var getTextMwaitModel = models.getTextAcsendModel;
    var view = BaseView.extend({
        viewName: 'activity_signupend',
        events: {
            'click .js_toPublish': 'toPublish'
        },
        render: function(html, parent) {
            this.$el.html(html);
        },
        onShow: function() {
            this.activityid = Turtle.getQuery('activityid');

            this.showLoading();
            getTextMwaitModel.excute(function(json) {
                this.hideLoading();
                this.render(_.template(tplArticleview)(json.result));
            }, function(msg) {
                this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            }, false, this);
        },
        toPublish:function(e){
            this.jump(['views/activityview.html','?activityid=',this.activityid,'&from=views/activity.html&'].join(''));
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back2",
                    event: function(event) {
                        if (Turtle.isInApp) {
                            var ws = plus.webview.getWebviewById('views/activityview.html');
                            if (ws && ws.param && ws.param.length) {
                                plus.webview.close(ws);
                            }
                        }
                        self.jump(['views/activityview.html','&activityid=',Turtle.getQuery('activityid')].join(''));
                    }
                }],
                centerHandler: [{
                    title: "我要报名",
                    className: "title"
                }],
                rightHandler: [{

                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});