define(['BaseView', 'Model', 'Store', 'text!TemplatesCeshi', 'util', 'UISlide'], function(BaseView, models, store, tplArticleview,  util, UISlide) {
    var isLogin = util.isLogin();
    var view = BaseView.extend({
        viewName: 'ceshi',
        events: {
            // 'click .js_toPublish': 'toPublish'
        },
        render: function(html, parent) {
            this.$el.html(html);
        },
        onShow: function() {
            this.render(_.template(tplArticleview)());
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back2",
                    event: function(event) {
                        self.jump(['views/activity.html'].join(''));
                    }
                }],
                centerHandler: [{
                    title: "食谱",
                    className: "title"
                }],
                rightHandler: [{

                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});