define(['BaseView', 'Model', 'Store', 'text!TemplatesError'], function(BaseView, models, store, tplError) {

    // var getArticleListsModel = models.getArticleListsModel;

    var view = BaseView.extend({
        viewName: 'error',
        events: {
            'click .backPrev': 'toPrev',
            'click .backIndex': 'toIndex'
        },
        render: function(html) {
            this.$el.html(html);
        },
        onShow: function() {
            this.render(_.template(tplError)());
        },
        toPrev: function() {
            this.back();
        },
        toIndex: function() {
            this.jump(['views/article.html'].join(''));
        }

    });

    this.viewIntance = view.getIntance();
});