define(['BaseView', 'Model', 'Store', 'text!TemplatesMapShow', 'util', 'UISlide'], function(BaseView, models, store, tplArticleview,  util, UISlide) {
    var isLogin = util.isLogin();
    var getMapMerchantModel = models.getMapMerchantModel;
    var view = BaseView.extend({
        viewName: 'mapshow',
        events: {

        },
        render: function(html, parent) {
            this.$el.html(html);
        },
        onShow: function() {
            this.render(_.template(tplArticleview)());

            var x = Turtle.getQuery('posx');
            var y = Turtle.getQuery('posy');
            map = new BMap.Map('js_maplist');
            var point = new BMap.Point(x,y);
            map.centerAndZoom(point, 17);
            map.addControl(new BMap.NavigationControl({anchor: BMAP_ANCHOR_TOP_RIGHT, type: BMAP_NAVIGATION_CONTROL_ZOOM}));
            var self = this;
             var myIcon = new BMap.Icon(Turtle.baseUrl + "/../resource/images/map_icon_search.png", new BMap.Size(13,19));
            var mk = new BMap.Marker(point,{icon:myIcon});
            map.addOverlay(mk);
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back2",
                    event: function(event) {
                        self.back();
                    }
                }],
                centerHandler: [{
                    title: "地图",
                    className: "title"
                }],
                rightHandler: [{
                    value: '',
                    className: "",
                    event: function(event) {
                        self.jump(['views/activity.html'].join(''));
                    }
                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
    function getInfo(jsonObj){
        // alert(jsonObj.name);
        $(".merchantinfo").hide();
        $("#merchantinfo"+jsonObj.id).show();
    }

});