define(['BaseView', 'Model', 'Store', 'text!TemplatesMerchantEnd', 'util', 'UISlide'], function(BaseView, models, store, tplArticleview,  util, UISlide) {
    var isLogin = util.isLogin();
    var getTextMwaitModel = models.getTextMendModel;
    var view = BaseView.extend({
        viewName: 'merchant_end',
        events: {
            'click .js_toPublish': 'toPublish'
        },
        render: function(html, parent) {
            this.$el.html(html);
        },
        toPublish:function(e){
            this.jump(['views/activity.html'].join(''));
        },
        onShow: function() {
            this.showLoading();
            getTextMwaitModel.excute(function(json) {
                this.hideLoading();
                this.render(_.template(tplArticleview)(json.result));
            }, function(msg) {
                this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            }, false, this);
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back2",
                    event: function(event) {
                        self.jump(['views/activity.html'].join(''));
                    }
                }],
                centerHandler: [{
                    title: "",
                    className: "申请结果"
                }],
                rightHandler: [{

                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});