/*
 * update App 升级
 * 1.整包升级
 * 2.资源升级
 * 3.资源差量升级
 * 参数规定
 * param = {
 * 	appid: 
 *  version:
 * }
 * 返回result 
 * result = {
 * 	type: // 0 不用升级 // 1 整包升级 2资源升级 3 资源差量升级
 *  url: 升级包地址
 * }
 */

(function(){
	// 检测更新服务器地址
	var server = ''; 
	
	// 准备升级操作
	function initUpdate(){
		update({});
	}
	
	// 整包升级
	function update(data){
		var msg = data.msg || "\n面粉升级",
			title = data.title || "版本更新",
			url = data.url || "http://www.baidu.com";

		plus.nativeUI.confirm(msg, function(event){
			if (event.index == 0) {
				plus.runtime.openURL(url);
			}
		}, title, ["立即更新", "取  消"]);
	}
	
	// 资源升级
	function wgt(){
		
	}
	
	// 资源差量升级
	function wgtu(){
		
	}
	
	if(window.plus){
		initUpdate();
	}else{
		document.addEventListener('plusready', initUpdate, false);
	}
})();
