define(['BaseView', 'Model', 'Store', 'text!TemplatesDemo', 'util'], function(BaseView, models, store, tplDemo, util) {

    var isLogin = util.isLogin();
    var userInfoModel = models.userInfoModel;
    var userUpdateModel = models.userUpdateModel;
    var userQuitModel = models.userQuitModel;
    var headStore = store.headStore;

    if (isLogin) {
        userUpdateModel.url = userUpdateModel.url + util.getToken(); //他们的接口有问题必须这么写 不能用access_token
        userQuitModel.url = userQuitModel.url + util.getToken(); //他们的接口有问题必须这么写 不能用access_token
    }

    var view = BaseView.extend({
        viewName: 'demo',
        events: {
            'click .demoBtn': 'demoFunction'
        },
        render: function(html) {
            this.$el.html(html);
        },
        onShow: function() {
            // if (!isLogin) {
            //     this.jump(['views/login_phone.html', '?from=views/', this.viewName, '.html'].join(''));
            //     return;
            // }
            // this.showLoading();
            // userInfoModel.setParam({
            //     access_token: util.getToken()
            // });
            // userInfoModel.excute(function(json) {
            //     this.hideLoading();
            //     this.render(_.template(tplSet)(json.result));
            //     this.changeHeadInit();

            // }, function(msg) {
            //     this.hideLoading();
            //     this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            // }, false, this);

            this.render(_.template(tplDemo)()); //如上有ajax返回就是 json.result

        },
        demoFunction: function() {
            alert('demoFunction 绑定上这个元素');
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back",
                    event: function(event) {
                        self.back();
                    }
                }],
                centerHandler: [{
                    title: "DEMO页面",
                    className: "title"
                }],
                rightHandler: [{

                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});