define(['BaseView', 'Model', 'Store', 'text!TemplatesLoading'], function(BaseView, models, store, tplLoading) {
    var view = BaseView.extend({
        viewName: 'loading',
        events: {
            '.click .snow': 'toAriticle'
        },
        render: function(html) {
            this.$el.html(html);
        },
        toAriticle: function() {
            this.jump(['views/article.html'].join(''));
        },
        onShow: function() {
            this.render(_.template(tplLoading)());
            var self = this;
            setTimeout(function(){ self.jump(['views/article.html'].join(''));},1500);
        }
    });

    this.viewIntance = view.getIntance();
});