define(['BaseView', 'Model', 'Store', 'text!TemplatesMerchantNo', 'util', 'UISlide'], function(BaseView, models, store, tplArticleview,  util, UISlide) {
    var isLogin = util.isLogin();
    var view = BaseView.extend({
        viewName: 'merchant_no',
        events: {
            'click .js_toPublish': 'toPublish'
        },
        render: function(html, parent) {
            this.$el.html(html);
        },
        onShow: function() {
            this.render(_.template(tplArticleview)());
        },
        toPublish:function(e){
            this.jump(['views/merchant_publish.html'].join(''));
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back2",
                    event: function(event) {
                        self.back();
                        // var fromUrl = self._fromUrlStore.getAttr(self.viewName);
                        // if (Turtle.isInApp) {
                        //     mui.back(); // 目前采用直接回退
                        // } else {
                        //     if (fromUrl) {
                        //         //微信分享外链直接跳进来
                        //         if (Turtle.getQuery('isshare')) {
                        //             self.jump(['views/article.html'].join(''));
                        //             return;
                        //         }
                        //         self.jump(fromUrl)
                        //     } else {
                        //         self.jump(Turtle.homeUrl);
                        //     }
                        // }
                    }
                }],
                centerHandler: [{
                    title: "",
                    className: ""
                }],
                rightHandler: [{

                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});