define(['BaseView', 'Model', 'Store', 'SelectDate', 'UIDialog', 'text!TemplatesMerchantPublish', 'util', 'utilCropImage', ], function(BaseView, models, store, SelectDate, UIDialog, tplActivityPublish, util, utilCropImage) {

    var provinceList = {},
        cityList = {},
        areaList = {};

    var isLogin = util.isLogin();
    var uploadPhotoModel = models.uploadPhotoModel,
    getMerchantPublishModel = models.getMerchantPublishModel;

    // if (isLogin) {
    //     getActivityPublish.url = getActivityPublish.url + util.getToken(); //他们的接口有问题必须这么写 不能用access_token
    // }

    var param = {
        setPos:true,
        posx:0,
        posy:0
    };
    var msg = [];
    var now = (function() {
        var arr = [],
            d = new Date(),
            year = d.getFullYear(),
            month = d.getMonth(),
            day = d.getDate();

        for (var i = 0; i < 5; i++) {
            arr.push(year + i);
        }
        return {
            year: arr,
            month: month,
            day: day
        };
    }());
    var map = '';
    var geoc = '';
    var CLASS_MOVE = 's-move',
        CLASS_BACK = 's-back';

    var CLASS_MOVE_T = 'st-move',
        CLASS_BACK_T = 'st-back';

    var view = BaseView.extend({
        viewName: 'activity_publish',
        events: {
            'click #js_setmap':'setMamMark',
            'click #js_send': 'sendActivity',
            'click li .close': 'removeImg'
        },
        sendActivity: function(e) {
            var self = this;
            fn();
            if (msg.length == 0) {
                this.showLoading();
                param.access_token = util.getToken();
                var p = mapmarker.getPosition();
                param.posx = p.lng;
                param.posy = p.lat;
                getMerchantPublishModel.setParam(param);
                getMerchantPublishModel.excute(function(json) {
                    this.hideLoading();
                    this.showToast('申请成功', {
                        hideAction: function() {
                            // self.jump('views/merchant_end.html');
                            self.jump(['views/activity.html'].join(''));
                        }
                    });
                }, function(msg) {
                    this.hideLoading();
                    if (_.isObject(msg) && msg.message) {
                        this.showToast(msg.message);
                        return;
                    }
                    this.showToast('网络错误，请稍候重试。');
                }, false, this);
            } else {
                new UIDialog({
                    model: {
                        content: msg[0]
                    }
                }).show();
            }
        },
        render: function(html) {
            this.$el.html(html);
        },
        onShow: function() {
            this.render(_.template(tplActivityPublish)());

            this._cropImage();

            map = new BMap.Map('publishmap');
            var point = new BMap.Point(116.400244,39.92556);
            map.centerAndZoom(point, 17);
            map.addControl(new BMap.NavigationControl({anchor: BMAP_ANCHOR_TOP_RIGHT, type: BMAP_NAVIGATION_CONTROL_ZOOM}));

            geoc = new BMap.Geocoder();

            mapmarker = new BMap.Marker(point);  //创建标注
            icon = mapmarker.getIcon();
            icon.setSize(new BMap.Size(40,40));
            mapmarker.setIcon(icon);
            map.addOverlay(mapmarker);

            mapmarker.enableDragging();
            mapmarker.addEventListener("dragend", function saveInfo(){
                param.setPos = false;
                var p = mapmarker.getPosition();
                param.posx = p.lng;
                param.posy = p.lat;
                geoc.getLocation(p, function(rs){
                    var addComp = rs.addressComponents;
                    mapaddress = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
                    inputaddress = $("#js_address").val();
                    if(!inputaddress){
                        $("#js_address").val(mapaddress);
                    }else if(inputaddress == param.mapaddress){
                        $("#js_address").val(mapaddress);
                    }
                    param.mapaddress = mapaddress;
                });
            });

            map.addEventListener("dragend", function showInfo(){
                if(param.setPos)
                mapmarker.setPosition(map.getCenter());
            });

            var geolocation = new BMap.Geolocation();
            geolocation.getCurrentPosition(function(r){
                if(this.getStatus() == BMAP_STATUS_SUCCESS){
                    var mk = new BMap.Marker(r.point);
                    var label = new BMap.Label("您的当前位置",{offset:new BMap.Size(-30,-20)});
                    mk.setLabel(label);
                    map.addOverlay(mk);

                    map.panTo(r.point);
                    if(param.setPos)
                    mapmarker.setPosition(r.point);
                }
            },{enableHighAccuracy: true})

        },
        setMamMark: function(){
            var p = map.getCenter();
            mapmarker.setPosition(p);
            param.posx = p.lng;
            param.posy = p.lat;
            geoc.getLocation(p, function(rs){
                var addComp = rs.addressComponents;
                mapaddress = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
                inputaddress = $("#js_address").val();
                if(!inputaddress){
                    $("#js_address").val(mapaddress);
                }else if(inputaddress == param.mapaddress){
                    $("#js_address").val(mapaddress);
                }
                param.mapaddress = mapaddress;
            });
        },
        _cropImage: function() {
            var self = this;
            var options = {
                imageBox: '.imageBox',
                thumbBox: '.thumbBox',
                spinner: '.spinner',
                imgSrc: ''
            }
            var cropper;
            this.$el.find('#fileInput').on('change', function() {
                var reader = new FileReader();
                reader.onload = function(e) {
                    options.imgSrc = e.target.result;
                    cropper = new utilCropImage.cropbox(options);
                }
                reader.readAsDataURL(this.files[0]);
                this.files = [];
                self._toggleCrop();
            });
            $('#btnCrop').on('click', function() {
                var imgBase64 = cropper.getDataURL();
                self.uploadPhoto(imgBase64);
            });
            $('#btnZoomIn').on('click', function() {
                cropper.zoomIn();
            });
            $('#btnZoomOut').on('click', function() {
                cropper.zoomOut();
            });
            $('.js_close').on('click', function() {
                self._toggleCrop();
                self.$el.find('#fileInput').val('');
            });
        },
        _toggleCrop: function() {
            this.$el.find('.js_uploadPage').toggleClass('none');
        },
        uploadPhoto: function(imgBase64) {
            this.showLoading();
            uploadPhotoModel.setParam({
                file: imgBase64
            });
            uploadPhotoModel.excute(function(json) {
                this.hideLoading();
                this._toggleCrop();
                this.$el.find('#fileInput').val('');
                this._appendImg(imgBase64, json.result);
            }, function(msg) {
                this.hideLoading();

                if (_.isObject(msg) && msg.message) {
                    this.showToast(msg.message);
                    return;
                }
                this.showToast('网络错误，请稍候重试。');
            }, false, this);
        },
        _appendImg: function(imgBase64, sDataUrl) {
            $(".tu").remove();
            var zpAdd = this.$el.find('.js_add');
            var zpItem = $('<li class="tu" />');
            var zpImg = $('<img/>').attr('src', imgBase64);
            var zpClose = $('<div class="close">×</div>');
            zpItem.data('url', sDataUrl).append(zpImg).append(zpClose);
            zpAdd.before(zpItem);
        },
        removeImg: function(e) {
            var zpClose = $(e.currentTarget);
            zpClose.parent().remove();
        },
        getImgUrls: function() {
            var zpItems = this.$el.find('.tu');
            var aImgUrls = [];
            zpItems.each(function() {
                if ($(this).data('url')) {
                    aImgUrls.push($(this).data('url'));
                }
            });
            return aImgUrls;
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    value: '',
                    className: "icon back2",
                    event: function(event) {
                        self.back();
                    }
                }],
                centerHandler: [{
                    title: "申请成为商户",
                    className: "title"
                }],
                rightHandler: [{}]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();

    // help
    function fn() {
        msg = [];
        vAt();
        vAtp();
        vAtr();
        vAddress();
        vImg();
    }

    function vAt() {
        var $elAt = $('#js_at'),
            // $elTips = $('#js_act_tips'),
            val = $.trim($elAt.val()),
            bool = false;

        if (val.length > 0) {
            bool = isStrLen(val, 56);
        }

        if (bool) {
            param.name = val;
            // $elTips.hide();
        } else {
            // $elTips.show();
            msg.push('请填写活动标题');
        }
    }
    function vAtp() {
        var $elAt = $('#js_atp'),
            // $elTips = $('#js_act_tips'),
            val = $.trim($elAt.val()),
            bool = false;

        if (val.length > 0) {
            bool = isStrLen(val, 56);
        }

        if (bool) {
            param.phone = val;
            // $elTips.hide();
        } else {
            // $elTips.show();
            msg.push('请填写商户电话');
        }
    }
    function vAtr() {
        var $elAt = $('#js_atr'),
            // $elTips = $('#js_act_tips'),
            val = $.trim($elAt.val()),
            bool = false;

        if (val.length > 0) {
            bool = isStrLen(val, 56);
        }

        if (bool) {
            param.username = val;
            // $elTips.hide();
        } else {
            // $elTips.show();
            msg.push('请填写营业人');
        }
    }
    function vImg() {
        var zpItems = $('.tu');
        var aImgUrls = [];
        zpItems.each(function() {
            if ($(this).data('url')) {
                aImgUrls.push($(this).data('url'));
            }
        });

        if (aImgUrls.length > 0) {
            param.imageurl = aImgUrls.join(',');
        } else {
            msg.push('请上传营业执照');
        }
    }

    function vAddress() {
        var $elAddress = $('#js_address'),
            val = $.trim($elAddress.val()),
            bool = false;

        if (val.length > 0) {
            bool = isStrLen(val, 200);
        }

        if (bool) {
            param.address = val;
        } else {
            msg.push('请填写商户地址');
        }
    }

    function isStrLen(str, cutLen) {
        var result = false,
            num = 0,
            strLen = str.length;

        for (var i = 0; i < strLen; i++) {
            if (str.charCodeAt(i) > 255) {
                num += 2;
            } else {
                num++;
            }
        }

        if (num <= cutLen) {
            result = true;
        }
        return result;
    }
});