define(['BaseView', 'Model', 'Store', 'UIDialog', 'text!TemplatesRecipeDish','util','UISlide','Swiper'], function(BaseView,models, store, UIDialog,tplRecipeDish,util,UISlide,Swiper) {
    var stepid =0;
    var startPos = {x:0,y:0};
    var endPos={x:0,y:0};
    var getRecipesMaterialsModel = models.getRecipesMaterialsModel;
    var view = BaseView.extend({
        viewName: "recipe_dish",
        events: {
            'click .js_toBack':'toBack',
        },
        toBack:function(){
            if(this.stepid!=0){
                this.jump(['views/recipe_step.html?recipesid=',this.recipesid,'&stepid=',this.stepid,'&'].join(''));
            }else{
                this.jump(['views/recipeview.html?recipesid=',this.recipesid,'&'].join(''));
            }
        },
        render: function(html) {
            this.$el.html(html);
        },
        onShow: function() {
            this.showLoading();
            this.recipesid = Turtle.getQuery('recipesid');
            this.stepid = Turtle.getQuery('stepid');
            getRecipesMaterialsModel.setParam({
                access_token: util.getToken(),
                recipesid: this.recipesid
            });
            getRecipesMaterialsModel.excute(function(json) {
                this.hideLoading();
                this.render(_.template(tplRecipeDish)(json.result));
            }, function(msg) {
                this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            }, false, this);
        },
    });
    this.viewIntance = view.getIntance();
})