(function() {
    var baseUrl = Turtle.baseUrl + 'mvc/';

    if (typeof mui !== 'undefined') {
        baseUrl = Turtle.baseUrl + '../mvc/';
    }

    var isDebug = false;
    var config = {
        paths: {
            'Model': baseUrl + 'models/Model',
            'Store': baseUrl + 'models/Store',
            'util': baseUrl + 'resource/scripts/util',
            'utilValidate': baseUrl + 'resource/scripts/util.validate',
            'utilEncryption': baseUrl + 'resource/scripts/util.encryption',
            'utilCropImage': baseUrl + 'resource/scripts/util.cropimage',
            'utilLazyLoad': baseUrl + 'resource/scripts/util.lazyload',
            'iScroll': baseUrl + 'resource/scripts/iscroll',
            'InputClear': baseUrl + 'resource/scripts/input.clear',
            'SelectDate': baseUrl + 'resource/scripts/select.date',
            'Swiper': baseUrl + 'resource/scripts/swiper',
            'GameData': baseUrl + 'resource/scripts/game.data',
            //页面模板
            'TemplatesCeshi': baseUrl + 'templates/ceshi.html',
            'TemplatesActivity': baseUrl + 'templates/activity.html',
            'TemplatesActivityLoadingMore': baseUrl + 'templates/activity_loadingmore.html',
            'TemplatesActivityPublish': baseUrl + 'templates/activity_publish.html',
            'TemplatesActivityEnd': baseUrl + 'templates/activity_end.html',
            'TemplatesActivityMap': baseUrl + 'templates/activity_map.html',
            'TemplatesMapShow': baseUrl + 'templates/mapshow.html',
            'TemplatesMapShowActivity': baseUrl + 'templates/mapshow_activity.html',
            'TemplatesActivitySignup': baseUrl + 'templates/activity_signup.html',
            'TemplatesActivitySignupend': baseUrl + 'templates/activity_signupend.html',
            'TemplatesActivityUnflour': baseUrl + 'templates/activity_unflour.html',
            'TemplatesActivityview': baseUrl + 'templates/activityview.html',
            'TemplatesActivitycomment': baseUrl + 'templates/activitycomment.html',
            'TemplatesActivitycommentLoadingMore': baseUrl + 'templates/activitycomment_loadingmore.html',
            'TemplatesMerchantview': baseUrl + 'templates/merchantview.html',
            'TemplatesMerchantPublish': baseUrl + 'templates/merchant_publish.html',
            'TemplatesMerchantNo': baseUrl + 'templates/merchant_no.html',
            'TemplatesMerchantEnd': baseUrl + 'templates/merchant_end.html',
            'TemplatesMerchantWait': baseUrl + 'templates/merchant_wait.html',
            'TemplatesMerchantviewLoadingMore': baseUrl + 'templates/merchantview_loadingmore.html',
            'TemplatesArticle': baseUrl + 'templates/article.html',
            'TemplatesArticleLoadingMore': baseUrl + 'templates/article_loadingmore.html',
            'TemplatesArticleview': baseUrl + 'templates/articleview.html',
            'TemplatesDemo': baseUrl + 'templates/demo.html',
            'TemplatesError': baseUrl + 'templates/error.html',
            'TemplatesExpert': baseUrl + 'templates/expert.html',
            'TemplatesExpertLoadingMore': baseUrl + 'templates/expert_loadingmore.html',
            'TemplatesExpertview': baseUrl + 'templates/expertview.html',
            'TemplatesFeedback': baseUrl + 'templates/feedback.html',
            'TemplatesGame': baseUrl + 'templates/game.html',
            'TemplatesGameReg': baseUrl + 'templates/game_reg.html',
            'TemplatesGameList': baseUrl + 'templates/game_list.html',
            'TemplatesGameGuize': baseUrl + 'templates/game_guize.html',
            'TemplatesGameAchieve': baseUrl + 'templates/game_achieve.html',
            'TemplatesLoading': baseUrl + 'templates/loading.html',
            'TemplatesLogin': baseUrl + 'templates/login.html',
            'TemplatesLoginPhone': baseUrl + 'templates/login_phone.html',
            'TemplatesMap': baseUrl + 'templates/map.html',
            'TemplatesRegisterPhone': baseUrl + 'templates/register_phone.html',
            'TemplatesSafety': baseUrl + 'templates/safety.html',
            'TemplatesSet': baseUrl + 'templates/set.html',
            'TemplatesMyaa': baseUrl + 'templates/myaa.html',
            'TemplatesMyaaLoadingMore': baseUrl + 'templates/myaa_loadingmore.html',
            'TemplatesTest': baseUrl + 'templates/test.html',
            'TemplatesDemo_sky': baseUrl + 'templates/demo_sky.html',
            'TemplatesActivity_survey': baseUrl + 'templates/activity_survey.html',
            'TemplatesActivity_survey_form': baseUrl + 'templates/activity_survey_form.html',
            'TemplatesMask_layer': baseUrl + 'templates/mask_layer.html',
            'TemplatesRecipe': baseUrl + 'templates/recipe.html',
            'TemplatesRecipeview': baseUrl + 'templates/recipeview.html',
            'TemplatesRecipeviewa': baseUrl + 'templates/recipeviewa.html',
            'TemplatesRecipeStep': baseUrl + 'templates/recipe_step.html',
            'TemplatesRecipeStepa': baseUrl + 'templates/recipe_stepa.html',
            'TemplatesRecipeDish': baseUrl + 'templates/recipe_dish.html',
            'TemplatesRecipeTime': baseUrl + 'templates/recipe_time.html',
            'TemplatesResetPassword': baseUrl + 'templates/reset_password.html',
        }
    };

    if (isDebug) {
        config.urlArgs = "v=" + Date.now();
    }

    require.config(config);
})();