define(function (){
	/**
    * @method InputClear
    * @param input {dom}                 需要添加功能的文本框
    * @param cascadeCallback {function}  级联回调函数
    */
	var InputClear = function (input, focusCallback, blurCallback, cascadeCallback) {
		var $input = typeof input == 'string' ? $(input) : input,
			$parent = $input.parent();
		    //$clearButton = $('<span class="clearInputBtn"></span>');

		//$parent.before($clearButton);

		function fn (){
			typeof cascadeCallback == 'function' && cascadeCallback();
		}

		$input.bind({
			'focus': function (e) {
				var val = $.trim($input.val());

				// if (val != '') {
	   			// 	$clearButton.show();
	   			// }
	   			focusCallback && focusCallback(e);
	            fn();
			},
			'input': function () {
				setTimeout(function () {
					//var val = $input.val();

					// if (val == '') {
					// 	$clearButton.hide();
					// } else {
					// 	$clearButton.show();
					// }
					fn();
				}, 10);
			},
			'blur': function (e) {
				blurCallback && blurCallback(e);
				fn();
				// setTimeout(function () {
				// 	$clearButton.hide();
				// }, 200);
			}
		});

		// $clearButton.bind({
		// 	'click': function () {
		// 		$input.val('');
  //               $input.keyup();
  //               $clearButton.hide();
  //               $input.focus();
  //               //$input.trigger('input');
  //               fn();
		// 	}
		// });
	}

	return InputClear;
});